<!doctype html>
<head>
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
</head>
<body>
  <div></div>
  <script src="js/main.js"></script>
  <script type="module">
    import { connectGanCube } from "./js/gan-web-bluetooth.js";

    const getMACAddress = async () => {
      // check localstorage
      let stored = localStorage.getItem("mac");
      if (stored) return stored;

      // if not stored, ask for it
      const macAddress = prompt("Input the MAC address of your GAN cube.");
      localStorage.setItem("mac", macAddress);
      return macAddress;
    };

    var w = Math.max(
      document.documentElement.clientWidth,
      window.innerWidth || 0
    );
    var h = Math.max(
      document.documentElement.clientHeight,
      window.innerHeight || 0
    );

    var flags = {w: w, h: h}

    const app = Elm.Main.init({ flags: flags, node: document.querySelector("div") });

    // connectCube port
    app.ports.connectCube.subscribe(async () => {
      window.cube = await connectGanCube(getMACAddress);

      // ganCubeEvent port
      cube.events$.subscribe((event) => {
        console.log(event);
        app.ports.ganCubeEvent.send(event);
      });

      await cube.sendCubeCommand({ type: "REQUEST_FACELETS" });
    });

    // sendCubeCommand port
    app.ports.sendCubeCommand.subscribe(async (value) => {
      await window.cube.sendCubeCommand(value);
    });
  </script>
</body>
